/*  $Header: /home/cvsroot/dvipdfmx/src/pdfcolor.h,v 1.1 2004/08/01 12:58:25 hirata Exp $
    
    This is dvipdfmx, an eXtended version of dvipdfm by Mark A. Wicks.

    Copyright (C) 2002 by Jin-Hwan Cho and Shunsaku Hirata,
    the dvipdfmx project team <dvipdfmx@project.ktug.or.kr>
    
    Copyright (C) 1998, 1999 by Mark A. Wicks <mwicks@kettering.edu>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
*/

#ifndef _PDF_COLOR_H_
#define _PDF_COLOR_H_

#define PDF_COLOR_DEV_GRAY -1
#define PDF_COLOR_INVALID  -2
#define PDF_COLOR_DEV_RGB  -3
#define PDF_COLOR_DEV_CMYK -4

#define PDF_COLOR_COMPONENT_MAX 4

typedef struct pdf_color
{
  int    space_id;
  double values[PDF_COLOR_COMPONENT_MAX];
} pdf_color;

extern int pdf_color_by_name (pdf_color *color, const char *color_name);

extern pdf_color *pdf_color_default        (void);
extern pdf_color *pdf_color_current_stroke (void);
extern pdf_color *pdf_color_current_fill   (void);
extern pdf_color *pdf_color_bgcolor        (void);

extern void pdf_color_setcolor    (const pdf_color *color_stroke,
				   const pdf_color *color_fill);
extern void pdf_color_set_bgcolor (const pdf_color *color);
extern void pdf_color_set_default (const pdf_color *color);

extern int  pdf_sprint_color_values (char *buf, const pdf_color *color);

/* Color special */
extern pdf_color *pdf_color_stack_top (void);
extern void pdf_color_stack_clear (void);
extern void pdf_color_stack_push  (const pdf_color *color);
extern void pdf_color_stack_pop   (void);

#endif /* _PDF_COLOR_H_ */
